' this is my second OOP style (sub/functions in TYPE block) programming project. 
' (I am new at this OOP thing)
' this is a JoyPad object that simplifies joypad processing.
' also it will return joypad direction in 8-way style.
' 
' 
' JOYPAD refers joypad attached on computer
' joystick refers one of 4 analog stick on each joypad.
'
'
'
'
#INCLUDE ONCE "fbgfx.bi"
USING fb

TYPE JOYPAD

   PRIVATE:

   'joypad device number. first joypad on computer is 0. second one is 1...
   _id AS INTEGER

   'joypad button information
   _button_pressed AS INTEGER

   'analog stick values (4 analog sticks per joypad)
   _x_axis(3) AS SINGLE
   _y_axis(3) AS SINGLE

   'if any analog stick on joypad is 'X-axis and Y-axis swapped', set this flag. 
   _swap_x_axis_and_y_axis(3) AS INTEGER

   PUBLIC:

   DECLARE CONSTRUCTOR (BYVAL JoyPad_ID AS INTEGER = 0)
   DECLARE DESTRUCTOR ()

   'set joypad ID
   DECLARE SUB set_id(BYVAL JoyPad_ID AS INTEGER = 0)

   'if X axis and Y axis on any analog sticks are swapped, set the flag.
   'x axis and y axis value will be swapped after polling joypad information.
   DECLARE SUB swap_x_y_axis(BYVAL stick_id AS INTEGER = 0)

   'change button setting
   'DECLARE SUB SET_BUTTON(BYREF new_button AS INTEGER)
   DECLARE FUNCTION set_button(BYREF new_button AS INTEGER) AS INTEGER

   'get joypad information and store internally
   DECLARE SUB poll()

   'calculate joypad direction in 8 way. (same style was used in some 8 bit PC too.)
   DECLARE FUNCTION direction(BYVAL stick_number AS INTEGER = 0) AS INTEGER

   'get the actual joypad axis values. (if you don't like above 8-way style)
   DECLARE FUNCTION x_axis(BYVAL stick_number AS INTEGER = 0) AS SINGLE
   DECLARE FUNCTION y_axis(BYVAL stick_number AS INTEGER = 0) AS SINGLE

   'get button information. use parameter to check each buttons or...
   'when parameter is omitted, it will return whole 32-bit button status.
   DECLARE FUNCTION button(BYVAL which_button AS INTEGER = -1) AS INTEGER

END TYPE
